=== contrib/marat/pdb-utils/Makefile ===
#
# Makefile For Response/Local Potential Calculation
#
EXE     = transform_pdb
SRCS = \
main.f smd_pdb.f
OBJS =$(SRCS:.f=.o)
${EXE}: $(OBJS) ;
	${FC} -o ${EXE} ${OBJS}

clean:
	rm -rf *.o transform_pdb
