=== debian/changelog ===
nwchem (7.3.0-1) unstable; urgency=medium

  * New upstream release. Closes: #1111575.
    - applies debian patch 32bit_overflow_n2_ccsd_2824153.patch
    - supports gcc-15 (C23 standard). Closes: #1097484.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Oct 2025 00:01:46 +0100

nwchem (7.2.3-10) unstable; urgency=medium

  * rebuild against ga (libglobalarrays-dev) 5.9.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 May 2025 22:07:59 +0200

nwchem (7.2.3-9) unstable; urgency=medium

  * ensure nwchem is rebuilt for the version of mpich (really4.2.1)
    targetted for trixie

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 May 2025 03:41:12 +0200

nwchem (7.2.3-8) unstable; urgency=medium

  * rebuild against libglobalarrays-dev 5.9.1
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Fri, 18 Apr 2025 20:49:20 +0200
