=== debian/tests/control ===
Depends: nwchem,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite.sh
Restrictions: allow-stderr

Depends: nwchem-openmpi,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite-openmpi
Architecture: !armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32
Restrictions: allow-stderr

Depends: nwchem-mpich,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite-mpich
Restrictions: allow-stderr
