=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/nwchemgit/nwchem/releases \
 (?:.*?/)?nwchem-@ANY_VERSION@-release.*-src\..*@ARCHIVE_EXT@
